# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class SpotInstanceRequest(pulumi.CustomResource):
    """
    Provides an EC2 Spot Instance Request resource. This allows instances to be
    requested on the spot market.
    
    By default Terraform creates Spot Instance Requests with a `persistent` type,
    which means that for the duration of their lifetime, AWS will launch an
    instance with the configured details if and when the spot market will accept
    the requested price.
    
    On destruction, Terraform will make an attempt to terminate the associated Spot
    Instance if there is one present.
    
    Spot Instances requests with a `one-time` type will close the spot request
    when the instance is terminated either by the request being below the current spot
    price availability or by a user.
    
    ~> **NOTE:** Because their behavior depends on the live status of the spot
    market, Spot Instance Requests have a unique lifecycle that makes them behave
    differently than other Terraform resources. Most importantly: there is __no
    guarantee__ that a Spot Instance exists to fulfill the request at any given
    point in time. See the [AWS Spot Instance
    documentation](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-spot-instances.html)
    for more information.
    
    """
    def __init__(__self__, __name__, __opts__=None, ami=None, associate_public_ip_address=None, availability_zone=None, block_duration_minutes=None, cpu_core_count=None, cpu_threads_per_core=None, credit_specification=None, disable_api_termination=None, ebs_block_devices=None, ebs_optimized=None, ephemeral_block_devices=None, get_password_data=None, iam_instance_profile=None, instance_initiated_shutdown_behavior=None, instance_interruption_behaviour=None, instance_type=None, ipv6_address_count=None, ipv6_addresses=None, key_name=None, launch_group=None, monitoring=None, network_interfaces=None, placement_group=None, private_ip=None, root_block_device=None, security_groups=None, source_dest_check=None, spot_price=None, spot_type=None, subnet_id=None, tags=None, tenancy=None, user_data=None, user_data_base64=None, valid_from=None, valid_until=None, volume_tags=None, vpc_security_group_ids=None, wait_for_fulfillment=None):
        """Create a SpotInstanceRequest resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not ami:
            raise TypeError('Missing required property ami')
        __props__['ami'] = ami

        __props__['associatePublicIpAddress'] = associate_public_ip_address

        __props__['availabilityZone'] = availability_zone

        __props__['blockDurationMinutes'] = block_duration_minutes

        __props__['cpuCoreCount'] = cpu_core_count

        __props__['cpuThreadsPerCore'] = cpu_threads_per_core

        __props__['creditSpecification'] = credit_specification

        __props__['disableApiTermination'] = disable_api_termination

        __props__['ebsBlockDevices'] = ebs_block_devices

        __props__['ebsOptimized'] = ebs_optimized

        __props__['ephemeralBlockDevices'] = ephemeral_block_devices

        __props__['getPasswordData'] = get_password_data

        __props__['iamInstanceProfile'] = iam_instance_profile

        __props__['instanceInitiatedShutdownBehavior'] = instance_initiated_shutdown_behavior

        __props__['instanceInterruptionBehaviour'] = instance_interruption_behaviour

        if not instance_type:
            raise TypeError('Missing required property instance_type')
        __props__['instanceType'] = instance_type

        __props__['ipv6AddressCount'] = ipv6_address_count

        __props__['ipv6Addresses'] = ipv6_addresses

        __props__['keyName'] = key_name

        __props__['launchGroup'] = launch_group

        __props__['monitoring'] = monitoring

        __props__['networkInterfaces'] = network_interfaces

        __props__['placementGroup'] = placement_group

        __props__['privateIp'] = private_ip

        __props__['rootBlockDevice'] = root_block_device

        __props__['securityGroups'] = security_groups

        __props__['sourceDestCheck'] = source_dest_check

        __props__['spotPrice'] = spot_price

        __props__['spotType'] = spot_type

        __props__['subnetId'] = subnet_id

        __props__['tags'] = tags

        __props__['tenancy'] = tenancy

        __props__['userData'] = user_data

        __props__['userDataBase64'] = user_data_base64

        __props__['validFrom'] = valid_from

        __props__['validUntil'] = valid_until

        __props__['volumeTags'] = volume_tags

        __props__['vpcSecurityGroupIds'] = vpc_security_group_ids

        __props__['waitForFulfillment'] = wait_for_fulfillment

        __props__['arn'] = None
        __props__['instance_state'] = None
        __props__['network_interface_id'] = None
        __props__['password_data'] = None
        __props__['primary_network_interface_id'] = None
        __props__['private_dns'] = None
        __props__['public_dns'] = None
        __props__['public_ip'] = None
        __props__['spot_bid_status'] = None
        __props__['spot_instance_id'] = None
        __props__['spot_request_state'] = None

        super(SpotInstanceRequest, __self__).__init__(
            'aws:ec2/spotInstanceRequest:SpotInstanceRequest',
            __name__,
            __props__,
            __opts__)

