# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class AccountPasswordPolicy(pulumi.CustomResource):
    """
    -> **Note:** There is only a single policy allowed per AWS account. An existing policy will be lost when using this resource as an effect of this limitation.
    
    Manages Password Policy for the AWS Account.
    See more about [Account Password Policy](http://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_passwords_account-policy.html)
    in the official AWS docs.
    """
    def __init__(__self__, __name__, __opts__=None, allow_users_to_change_password=None, hard_expiry=None, max_password_age=None, minimum_password_length=None, password_reuse_prevention=None, require_lowercase_characters=None, require_numbers=None, require_symbols=None, require_uppercase_characters=None):
        """Create a AccountPasswordPolicy resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['allowUsersToChangePassword'] = allow_users_to_change_password

        __props__['hardExpiry'] = hard_expiry

        __props__['maxPasswordAge'] = max_password_age

        __props__['minimumPasswordLength'] = minimum_password_length

        __props__['passwordReusePrevention'] = password_reuse_prevention

        __props__['requireLowercaseCharacters'] = require_lowercase_characters

        __props__['requireNumbers'] = require_numbers

        __props__['requireSymbols'] = require_symbols

        __props__['requireUppercaseCharacters'] = require_uppercase_characters

        __props__['expire_passwords'] = None

        super(AccountPasswordPolicy, __self__).__init__(
            'aws:iam/accountPasswordPolicy:AccountPasswordPolicy',
            __name__,
            __props__,
            __opts__)

